//RTC commands:
#define RTC_EEREAD  0x03
#define RTC_EEWRITE 0x02
#define RTC_EEWRDI  0x04
#define RTC_EEWREN  0x06
#define RTC_SRREAD  0x05
#define RTC_SRWRITE 0x01
#define RTC_READ    0x13
#define RTC_WRITE   0x12
#define RTC_UNLOCK  0x14
#define RTC_IDWRITE 0x32
#define RTC_IDREAD  0x33
#define RTC_CLRRAM  0x54

//SPI function flags:
#define ADDRFLAG  0x01
#define WRITEFLAG 0x02
#define READFLAG  0x04

//7 segment display

#define SEG_A 0xdf
#define SEG_B 0xef //    aaaa
#define SEG_C 0xbf //   f    b
#define SEG_D 0x7f //   f    b
#define SEG_E 0xfd //hh  gggg
#define SEG_F 0xfb //   e    c
#define SEG_G 0xf7 //   e    c
#define SEG_H 0xfe //    dddd 

#define SYMB_0   (SEG_A & SEG_B & SEG_C & SEG_D & SEG_E & SEG_F        )
#define SYMB_1   (        SEG_B & SEG_C                                )
#define SYMB_2   (SEG_A & SEG_B         & SEG_D & SEG_E         & SEG_G)
#define SYMB_3   (SEG_A & SEG_B & SEG_C & SEG_D                 & SEG_G)
#define SYMB_4   (        SEG_B & SEG_C                 & SEG_F & SEG_G)
#define SYMB_5   (SEG_A         & SEG_C & SEG_D         & SEG_F & SEG_G)
#define SYMB_6   (SEG_A         & SEG_C & SEG_D & SEG_E & SEG_F & SEG_G)
#define SYMB_7   (SEG_A & SEG_B & SEG_C                                )
#define SYMB_8   (SEG_A & SEG_B & SEG_C & SEG_D & SEG_E & SEG_F & SEG_G)
#define SYMB_9   (SEG_A & SEG_B & SEG_C                 & SEG_F & SEG_G)
#define SYMB_A   (SEG_A & SEG_B & SEG_C         & SEG_E & SEG_F & SEG_G)
#define SYMB_B   (                SEG_C & SEG_D & SEG_E & SEG_F & SEG_G)
#define SYMB_C   (                        SEG_D & SEG_E         & SEG_G)
#define SYMB_D   (        SEG_B & SEG_C & SEG_D & SEG_E         & SEG_G)
#define SYMB_E   (SEG_A                 & SEG_D & SEG_E & SEG_F & SEG_G)
#define SYMB_F   (SEG_A                         & SEG_E & SEG_F & SEG_G)
#define SYMB_NUL (0xFF)
#define SYMB_o   (SEG_A & SEG_B                         & SEG_F & SEG_G)
#define SYMB_n   (SEG_A & SEG_B                         & SEG_F        )
#define SYMB_g   (SEG_A & SEG_B & SEG_C & SEG_D         & SEG_F & SEG_G)
#define SYMB_MIN (                                                SEG_G)
#define SYMB_DOT (SEG_H)

//operation modes
#define MODE_INIT 0
#define MODE_TIME 1
#define MODE_SETTIME 2
#define MODE_SETALARM 3
#define MODE_ALARM 4
#define MODE_DATE 5
#define MODE_SETDATE 6
#define MODE_SETYEAR 7
#define MODE_COUNTUP 8
#define MODE_SETCOUNTDOWN 9
#define MODE_COUNTDOWN 10

#define MODE_CALIBRATE 11
#define MODE_DEBUG 12
#define MODE_DEBUGADDR 13
#define MODE_DEBUGVAL 14

#define ALARMVALUE 0xa5